#!/usr/bin/perl
# Takes an input dictionary containg words whose paradigms
# are not known (UNKN), and generates a lex routine which
# substitutes the word by its equivalent, at least for the
# root form.
# For example the dictionary entries look like:
#  "ABU","UNKN","adj","1.aXapakA{anAja}","d1"
#  "ADA_lA","UNKN","vt","1.wakarAra/JagadZA_kara","d1"
#  "AI_calAI","UNKN","nf","1.sAxA_rahanasahana","d1"
# It would generate lex which sustitutes 'ABU' by 'aXapakA{anAja}' etc.

# print <<EOT;
# WORD [A-Za-z]*
# SEPARATOR [\",:;'\?><\]\[\}\{\)\( \n\t-_=!\@#%&\*\.\xea\\\/]
# SEP_COMPND [\*\t\n_\- \@\\\/]
# VOW1 [aeiouAEIOUqMH]
# VOW2 [eiouEIOUqMH]
# CONS [kKgGfcCjJFtTdDNwWxXnpPbBmyrlvSRsh]
# %%
# EOT

# Instead of above commented out text, copy from a file.
open (PREAMB, "/home/bharathi/PNJ1/usr3/sangal/tools/src/pdgm_dict/preamble.lex") ||
  die "Unable to open file /home/bharathi/PNJ1/usr3/sangal/tools/src/pdgm_dict/preamble.lex: $!\n";
while (<PREAMB>) { print; }

require("/home/bharathi/PNJ1/usr3/sangal/anusAraka/com2/dict/dict_mean_multi_sub.pl");

$sep = '{SEP_COMPND}';
$separ = '{SEPARATOR}';

while (<>) {
  chop;
  s/"//g;
  @flds =  split (/,/);
  if ($flds[1] eq 'UNKN') {
    $found = 1;
    $in = $flds[0];
    $out = dict_mean_multi ($flds[3]);
    #print STDERR 'DEBUG:', $in, ' -> ', $out, "\n";
    if ($in ne $out) {
      $found_diff = 1;
      print $separ, $in, '/', $separ, '   { printf("%c', 
          $out, '", yytext[0]); }', "\n";
    }
  }
}
if (!($found)) { print STDERR "unkn.pl: No unknown paradigm found.\n"; }
if (!($found_diff)) { print STDERR "unkn.pl: No word with unknown paradigm",
                              " requiring substitution found.\n"; }

# Commented out and required /home/bharathi/PNJ1/usr3/sangal/anusAraka/com2/dict/dict_mean_mulit.pl
## Given the meaning entry from a dictionary, returns the
## first word for each of the different meanings.
#sub dict_mean_multi {
#  local ($meaning) = $_;
#  local (@vals, $v, $match, $first, $out);
#    @vals = split (/\//, $meaning);
#    foreach $v (@vals) {
#      # print STDERR "DEBUG: Val: $v\n";
#      if ($v =~ /^[0-9]+\./) { # First word for a distinct meaning.
#        $match = $&;
#        $first = $';  
#        if ($first =~ /\/$/) { $first = $`; } # Remove trailing '/'
#        if ($match =~ /1\./) { # First word for the first meaning.
#          $out = $first;
#        }
#        else { $out .= '/' . $first; }
#      }
#    }
#  return ($out);
#}
