
/* this program converts the text in devanagri to roman 
 & vice versa.
 dtor :
 every devanagari word starts with nukwA.
 halanta is explicitly written by appending a halanta
 the characters Q,H,f & F (iitk_code) are mapped to   p,B,G & K respectively followed by nukwA ,in devanagari.
 
 rtod
 by default every character in roman is halant.
 lY & rY are followed by Y , hqsva-mAwrA-o & hqsva-mAwrA-e are followed by V.
 nukwA is denoted by Z.
 */
#include <stdio.h>
#include <string.h>

#define halanwa 'w'
#define nukwA 'x'
#define blank ' '
#define lY_code 101
#define rY_code 99
#define a_code 67
#define mawra_begin 107
#define mawra_end 119
#define chandra_bindu 65
#define anusvAra 66
#define F_code 75
#define Q_code 112
#define oV_code 116
#define eV_code 113
#define f_code 71
#define visarg_code 66
#define SP_CHAR 1 /* ascii<65 && >122 or between 91-96*/
#define CONSONENT 2
#define mAwrA 3
#define a_char 4
#define NUKWA 5
#define HALANWA 6
#define SP_MAWRA 7 /* visarga & chandra_bindu */

char gist_i_to_a[] = "zMakKgGcCjJtTdDNwWxXnpPbBm______yr_lYvSRshAiIuUqYeEYoO_H ";
char msc_i_to_a[] = "aAiIuU q   eE ooO k K g GfcCjJFtTd  D NwWxXnnpP bBmyyrrlllvSRsh 2AiIuUq345eeE ooO_  ";
unsigned char a_to_i[] = "kYIOsKGxmKE_BPvWphgMoeRTex______CXHNrGFjlJDdZUuVpbiLnfQSaA";


int mawra(ch)
unsigned  char ch;
{
	if ((ch == 'A')||(ch=='e')||(ch=='E')||(ch=='i')||(ch=='I')||(ch=='o')||(ch=='O')||(ch=='u')||(ch=='U')||(ch=='q')||(ch=='H')||(ch=='M')||(ch=='z')||(ch=='Q'))return 1; 
	else return 0;
}

int sp_char(ch)
unsigned char ch;
{
if((ch<65)||(ch>122)||((ch>90)&&(ch<97)))
return 1;
else return 0;
}

rtod()
{
int prev_type,curr_type;
char str[3];
prev_type=SP_CHAR;
curr_type=SP_CHAR;
while(curr_type!=EOF)
{
curr_type=get_gist_code(str);
switch(curr_type)
{
case a_char :   if(prev_type==SP_CHAR)
                {
                printf("%c",nukwA);
                printf("%c",a_code);
                }
                break;
case mAwrA:     if((prev_type==SP_CHAR)||(prev_type==mAwrA))
               {
                printf("%c",nukwA);
                if((str[0]!=visarg_code) && (str[0]!=Q_code)) printf("%c",a_code);
               }
                printf("%s",str);
                break;
case CONSONENT: if(prev_type==SP_CHAR)
                printf("%c",nukwA);
                if(prev_type==CONSONENT)
                printf("%c",halanwa);
                printf("%s",str);
                break;
case SP_CHAR: if(prev_type==CONSONENT)
              printf("%c",halanwa);
	      printf("%s",str);
              break;
}
prev_type=curr_type;
}
return;
}

int get_gist_code(strng)
char strng[3];
{
char f,s,t;
int char_type;
f=getchar();
if(f==EOF)
{
char_type=EOF;
return(char_type);
}
/* 	if special character return it. */
if(sp_char(f))
{
strng[0]=f;
strng[1]='\0';
char_type=SP_CHAR;
return(char_type);
}
/* else following cases can be determined without lookahead. */
switch(f)
{
case 'f':
case 'F': strng[0]=a_to_i[f-65];
        strng[1]=nukwA;
        strng[2]='\0';
        char_type=CONSONENT;
        return(char_type);
case 'Q': strng[0]=Q_code;
case 'H': strng[0]=visarg_code;
        strng[1]=nukwA;
        strng[2]='\0';
        char_type=mAwrA;
        return(char_type);
case 'a': strng[0]=a_to_i[f-65];
	  strng[1]='\0';
	  char_type=a_char;
          return(char_type);
default : break;
}
/* if not a special character & also can not be determined without a look ahead see the next character. 
following_character 	case
	Z		nukwA
	V		ascii code = ascii of the previous character.
	Y		ascii code = ascii of the next character. */

s=getchar();
switch(s)
{
case 'Z' : strng[0]=a_to_i[f-65];
         strng[1]=nukwA;
         strng[2]='\0';
         char_type=CONSONENT;
         return(char_type);
case 'V' : strng[0]=a_to_i[f-65]-1;
           strng[1]='\0';
           if(mawra(f)) char_type=mAwrA; else char_type=CONSONENT;
           return(char_type);
case 'Y' : strng[0]=a_to_i[f-65]+1;
           t=getchar();
           if(t=='Z')
             {
              strng[1]=nukwA;
              strng[2]='\0';
             }
           else 
             {
              ungetc(t,stdin);
              strng[1]='\0';
             }
         char_type=CONSONENT;
         return(char_type);
default:  ungetc(s,stdin);
          strng[0]=a_to_i[f-65];
	  strng[1]='\0';
          if(mawra(f)) char_type=mAwrA; else char_type=CONSONENT;
          return(char_type);
}
}



int get_iitk_code(strng)
char strng[3];
{
char f,s,t;
int char_type;
f=getchar();
switch(f)
{
case EOF: char_type=EOF;
          return(char_type);
case nukwA: strng[0]='\0';
            char_type=NUKWA;
            return(char_type);
case halanwa: strng[0]='\0';
              char_type=HALANWA;
              return(char_type);
case Q_code:
case f_code : 
case visarg_code:
case F_code : s=getchar();
              if(s==nukwA)
              {
              switch(f)
              {
              case f_code: strng[0]='f';
                           char_type=CONSONENT;
                           break;
              case F_code: strng[0]='F';
                           char_type=CONSONENT;
                           break;
              case Q_code:strng[0]='Q';
                          char_type=mAwrA;
                           break;
              case visarg_code:strng[0]='H';
                               char_type=SP_MAWRA;
                               break;
              }
              strng[1]='\0';
              return(char_type);
              }
              else 
              {
              ungetc(s,stdin);
              strng[0]=gist_i_to_a[f-65];
              strng[1]='\0';
              if(f=='B') char_type=SP_MAWRA;
              else char_type=CONSONENT;
              return(char_type);
              }
case lY_code:
case rY_code: 
             strng[0]=gist_i_to_a[f-65-1];
             strng[1]='Y';
             strng[2]='\0';
             char_type=CONSONENT;
             return(char_type);
case oV_code:
case eV_code:
             strng[0]=gist_i_to_a[f-65+1];
             strng[1]='V';
             strng[2]='\0';
             char_type=mAwrA;
             return(char_type);
case a_code: s=getchar();
             if(gist_mawra(s))
             {
             switch(s)
	     {
		case lY_code:
		case rY_code: 
		             strng[0]=gist_i_to_a[s-65-1];
		             strng[1]='Y';
		             strng[2]='\0';
		             char_type=mAwrA;
		             return(char_type);
		case oV_code:
		case eV_code:
		             strng[0]=gist_i_to_a[s-65+1];
		             strng[1]='V';
		             strng[2]='\0';
		             char_type=mAwrA;
		             return(char_type);
	        default:    ungetc(t,stdin);
                            strng[0]=gist_i_to_a[s-65];
                            strng[1]='\0';
		            char_type=mAwrA;
		            return(char_type);
             }
             }
             else
             {
             ungetc(s,stdin);
             strng[0]=gist_i_to_a[f-65];
             strng[1]='\0';
             char_type=a_char;
             return(char_type);
             }
default     : if(sp_char(f)) 
              {
              strng[0]=f;
              char_type=SP_CHAR;
              }
              else 
              {
              if(gist_mawra(f)) char_type=mAwrA;
              if(f=='B') char_type=SP_MAWRA;
              else  char_type=CONSONENT;
              strng[0]=gist_i_to_a[f-65];
              }
              strng[1]='\0';
              return(char_type);
}
}



dtor()
{
int prev_type,curr_type;
char str[3];
prev_type=SP_CHAR;
curr_type=SP_CHAR;
while(curr_type!=EOF)
{
curr_type=get_iitk_code(str);
if((prev_type==CONSONENT)&&((curr_type==CONSONENT)||(curr_type==SP_CHAR)||(curr_type==SP_MAWRA)))
  {
   printf("a");
   printf("%s",str);
  }
else printf("%s",str);
prev_type=curr_type;
}
}

int gist_mawra(ch)
unsigned char ch;
{
if((ch>=mawra_begin)&&(ch<=mawra_end)) return 1; else return 0;
}



main(argc,argv)
int argc;
char *argv[];
{
int ROMAN;
if(argc > 1)
   if (index(argv[1] , 'r')) ROMAN =1;
if(ROMAN) dtor(); else rtod();
}

